package com.css.simulation.resource.scheduler.infra.db.mysql.mapper;

import api.common.pojo.po.scene.SceneComputerRateDTO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;


@Mapper
public interface SceneComputerRateMapper {

    @Insert("        insert into simulation.scene_computer_rate\n" +
            "        (computer_rate_id, computer_type, rule_id, algorithm_id,vehicle_id,task_id,\n" +
            "         computer_result, scene_id_list,\n" +
            "         is_deleted, create_user_id, create_time\n" +
            "        )\n" +
            "        values (#{computerRateId,jdbcType=VARCHAR}, #{computerType,jdbcType=VARCHAR}, #{ruleId,jdbcType=VARCHAR},\n" +
            "                #{algorithmId,jdbcType=VARCHAR},#{vehicleId,jdbcType=VARCHAR},#{taskId,jdbcType=VARCHAR},\n" +
            "                #{computerResult,jdbcType=VARCHAR}, #{sceneIdList,jdbcType=VARCHAR},\n" +
            "                #{isDeleted,jdbcType=VARCHAR},\n" +
            "                #{createUserId,jdbcType=VARCHAR},\n" +
            "                #{createTime})")
    void saveSceneComputerRate(SceneComputerRateDTO params);

    @Results(id = "sceneComputerRateResult", value = {
            @Result(column = "computer_rate_id", property = "computerRateId", jdbcType = JdbcType.VARCHAR),
            @Result(column = "computer_type", property = "computerType", jdbcType = JdbcType.VARCHAR),
            @Result(column = "computer_result", property = "computerResult", jdbcType = JdbcType.VARCHAR),
    })
    @Select("select computer_rate_id, computer_type, computer_result " +
            "from simulation.scene_computer_rate where computer_type = #{computerType} and is_deleted = 0")
    SceneComputerRateDTO loadSceneComputerRate(@Param("computerType") String computerType);

    @Update("update simulation.scene_computer_rate set is_deleted = 1 " +
            "where computer_rate_id = #{computerRateId} and  computer_type = #{computerType}")
    void deleteByIdAndType(@Param("computerRateId") String computerRateId, @Param("computerType") String computerType);

    @Update("update simulation.scene_computer_rate set computer_result = #{computerResult} " +
            "where computer_rate_id = #{computerRateId} and  computer_type = #{computerType}")
    void updateResultByIdAndType(@Param("computerRateId") String computerRateId, @Param("computerType") String computerType,
                                 @Param("computerResult") String computerResult);
}
