package com.css.simulation.resource.server.app.service;

import api.common.pojo.vo.project.SceneComputerECRateVo;
import api.common.pojo.vo.scene.CoveragePrefixStatusVO;
import com.css.simulation.resource.server.infra.db.entity.SceneComputerRateEntity;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author zhoutianfu
 * @update 2025/3/2 13:20
 * @since 2025/3/2 13:20
 **/
public interface SceneComputerRateService {

    void saveSceneComputerRate(SceneComputerRateEntity params);

    void deleteByIdAndType(@Param("computerRateId") String computerRateId, @Param("computerType") String computerType);

    /**
     * 根据项目id和场景计算类型查询覆盖率，暴露率等数据
     * @param projectId projectId
     * @param computerTypeList computerTypeList
     * @return List<SceneComputerECRateVo>
     */
    List<SceneComputerECRateVo>  selectProjectComputerRates(String projectId, List<String> computerTypeList);

    SceneComputerRateEntity loadSceneCoveragePrefixKeyNums();

    CoveragePrefixStatusVO loadConvergePrefixStatus();
}
